Getting started with React Form Renderer component

06 Aug 202611 minutes to read

The Form Renderer is a powerful, schema-driven component that enables you to build and render complex forms with ease using a structured JSON schema definition. It streamlines form creation, customization, and data capture by letting you declaratively define form layouts, fields, and validation rules, and then render the form with a simple component property binding.

This guide provides step-by-step instructions for setting up a Vite + React project with TypeScript and integrating the Syncfusion® React Form Renderer component. For other setup flows (Create React App, framework host setups), see See Also.

Prerequisites

Set up the Vite project

To create a new React application, run one of the following commands based on your preferred language:

React with JavaScript

npm create vite@latest my-project -- --template react
yarn create vite my-project --template react

React with TypeScript

npm create vite@latest my-project -- --template react-ts
yarn create vite my-project --template react-ts

During the setup process, the CLI will prompt you for a few configuration options. Select the following:

  • Which linter to use? → ESLint
  • Install with npm and start now? → Yes

Selecting Yes automatically installs the project dependencies and starts the development server.

After verifying that the application starts successfully, terminate the development server in the terminal and proceed to the next step.

Then, navigate to the project directory:

cd my-project

Add Syncfusion® React packages

All Syncfusion Essential® JS 2 packages are published to the npm registry.

To install the React Form Renderer package, use the following command:

npm install @syncfusion/ej2-react-form-renderer
yarn add @syncfusion/ej2-react-form-renderer

Import Syncfusion® CSS styles

Themes for Syncfusion® React components can be applied using CSS or SASS files from the npm theme packages, CDN, CRG, or Theme Studio. For more information, see the themes documentation.

This guide uses the Material 3 theme as an example, sourced from the theme package. To install the Material 3 theme package, use the following command:

npm install @syncfusion/ej2-material3-theme
yarn add @syncfusion/ej2-material3-theme

By default, Vite projects include a src/index.css file with default styles. These default styles may conflict with Syncfusion component styles. Clear all content from the src/index.css file to prevent style conflicts.

The required styles for the Form Renderer are imported in the src/App.css file:

@import "@syncfusion/ej2-material3-theme/styles/material3.css";

Adding the Form Renderer component

Now, add the React Form Renderer component to the src/App.tsx file by importing and using it within the application.

The Form Renderer is a schema-driven component. Create your form by passing a JSON schema to the schema property of the <FormRendererComponent> element, and capture the submitted form data through the submit event.

Add the following code to the src/App.tsx file:

import { FormRendererComponent, Schema } from '@syncfusion/ej2-react-form-renderer';
import './App.css';

function App() {
  const schema: Schema = {
    "version": "0.1.0",
    "properties": {
      "emailAddress": {
        "id": "textbox_1785491685456_167",
        "name": "emailAddress",
        "type": "string",
        "label": "Email Address",
        "textboxType": "email",
        "required": true,
        "widget": "textbox"
      },
      "password": {
        "id": "textbox_1785491685456_537",
        "name": "password",
        "type": "string",
        "label": "Password",
        "textboxType": "password",
        "required": true,
        "minLength": 6,
        "widget": "textbox"
      },
      "rememberMe": {
        "id": "checkbox_1785491685456_262",
        "name": "rememberMe",
        "type": "boolean",
        "label": "Remember Me",
        "widget": "checkbox"
      },
      "submit": {
        "id": "submit_button_initial",
        "name": "defaultFormsubmit",
        "type": "button",
        "label": "Submit",
        "buttonType": "submit",
        "widget": "button",
        "style": "primary",
        "disabled": false
      }
    },
    "layout": [
      {
        "type": "field",
        "propertyId": "emailAddress"
      },
      {
        "type": "field",
        "propertyId": "password"
      },
      {
        "type": "field",
        "propertyId": "rememberMe"
      },
      {
        "type": "field",
        "propertyId": "submit"
      }
    ],
    "settings": {
      "name": "Untitled Form"
    }
  };

  const onSubmit = (args: any) => {
    if (args.data) {
      console.log(args.data, args.isValid);
    }
  };

  return (
    <FormRendererComponent schema={schema} submit={onSubmit} />
  );
}

export default App;
import { FormRendererComponent } from '@syncfusion/ej2-react-form-renderer';
import './App.css';

function App() {
  const schema = {
    "version": "0.1.0",
    "properties": {
      "emailAddress": {
        "id": "textbox_1785491685456_167",
        "name": "emailAddress",
        "type": "string",
        "label": "Email Address",
        "textboxType": "email",
        "required": true,
        "widget": "textbox"
      },
      "password": {
        "id": "textbox_1785491685456_537",
        "name": "password",
        "type": "string",
        "label": "Password",
        "textboxType": "password",
        "required": true,
        "minLength": 6,
        "widget": "textbox"
      },
      "rememberMe": {
        "id": "checkbox_1785491685456_262",
        "name": "rememberMe",
        "type": "boolean",
        "label": "Remember Me",
        "widget": "checkbox"
      },
      "submit": {
        "id": "submit_button_initial",
        "name": "defaultFormsubmit",
        "type": "button",
        "label": "Submit",
        "buttonType": "submit",
        "widget": "button",
        "style": "primary",
        "disabled": false
      }
    },
    "layout": [
      { "type": "field", "propertyId": "emailAddress" },
      { "type": "field", "propertyId": "password" },
      { "type": "field", "propertyId": "rememberMe" },
      { "type": "field", "propertyId": "submit" }
    ],
    "settings": {
      "name": "Untitled Form"
    }
  };

  const onSubmit = (args) => {
    if (args.data) {
      console.log(args.data, args.isValid);
    }
  };

  return (
    <FormRendererComponent schema={schema} submit={onSubmit} />
  );
}

export default App;

Run the application

Run the npm run dev command in the terminal to start the development server. This command compiles your code and serves the application locally, opening it in the browser.

npm run dev

When the build succeeds, Vite reports a local URL (default: http://localhost:5173). Open that URL in a browser to view the Form Renderer. If the port is already in use, Vite automatically picks the next free port and prints the new URL in the terminal.

The output will appear as follows:

React Form Renderer

See Also

Getting Started with the Vue Form Renderer Component in Vue 3

06 Aug 202614 minutes to read

The Form Renderer is a powerful, schema-driven component that enables you to build and render complex forms with ease using a structured JSON schema definition. It streamlines form creation, customization, and data capture by letting you declaratively define form layouts, fields, and validation rules, and then render the form with a simple component property binding.

This article provides a step-by-step guide for setting up a Vite project with a JavaScript environment and integrating the Syncfusion® Vue Form Renderer component using the Composition API / Options API.

The Composition API is a new feature introduced in Vue.js 3 that provides an alternative way to organize and reuse component logic. It allows developers to write components as functions that use smaller, reusable functions called composition functions to manage their properties and behavior.

The Options API is the traditional way of writing Vue.js components, where the component logic is organized into a series of options that define the component’s properties and behavior. These options include data, methods, computed properties, watchers, life-cycle hooks, and more.

Prerequisites

Ensure that the development environment meets the required criteria listed in System requirements for Syncfusion® Vue UI components.

Set Up the Vite Project

Easily set up a Vue 3 application using Vite, which provides a faster development environment, smaller bundle sizes, and optimized builds compared to traditional tools. For detailed steps, refer to the Vite installation instructions. Vite sets up your environment using JavaScript and optimizes your application for production.

Note: To create a Vue application using create-vue, refer to this documentation for more details.

To create a new Vue 3 application, run one of the following commands based on your preferred language:

Vue with JavaScript

npm create vite@latest my-app -- --template vue
yarn create vite@latest my-app -- --template vue

Vue with TypeScript

npm create vite@latest my-app -- --template vue-ts
yarn create vite@latest my-app -- --template vue-ts

During the setup process, the CLI will prompt you for a few configuration options. Select the following:

  • Install with npm and start now? → No

Selecting Yes automatically installs the project dependencies and starts the development server.

Then, navigate to the project directory:

cd my-app

Add Vue Form Renderer package

To install the Form Renderer package, use the following command:

npm install @syncfusion/ej2-vue-form-renderer
yarn add @syncfusion/ej2-vue-form-renderer

Adding CSS reference

Themes for Syncfusion® components can be applied using CSS files provided through npm theme packages. For available themes, refer to the Themes documentation.

Install the Material 3 theme package using the following command:

npm install @syncfusion/ej2-material3-theme --save

Then add the following CSS reference to the src/App.vue file:

<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/style/material3.css";
</style>

Adding Vue Form Renderer component

The Form Renderer is a schema-driven component. Define your form by passing a JSON schema to the schema property of the <ejs-form-renderer> element, and capture the submitted form data through the submit event.

The Form Renderer code should be added in the src/App.vue file.

<template>
  <ejs-formrenderer :schema="schema" :submit="onSubmit"></ejs-formrenderer>
</template>

<script>
import {
  FormRendererPlugin,
  FormRendererComponent
} from "@syncfusion/ej2-vue-form-renderer";

export default {
  name: "App",
  // Register the Form Renderer plugin so that all form fields are globally registered.
  provide: {
    FormRendererPlugin: [FormRendererPlugin]
  },
  components: {
    "ejs-formrenderer": FormRendererComponent
  },
  // Import the bundled module that wires up every built-in widget (textbox, checkbox, button, etc.).
  data() {
    return {
      schema: {
        version: "0.1.0",
        properties: {
          emailAddress: {
            id: "textbox_1785491685456_167",
            name: "emailAddress",
            type: "string",
            label: "Email Address",
            textboxType: "email",
            required: true,
            widget: "textbox"
          },
          password: {
            id: "textbox_1785491685456_537",
            name: "password",
            type: "string",
            label: "Password",
            textboxType: "password",
            required: true,
            minLength: 6,
            widget: "textbox"
          },
          rememberMe: {
            id: "checkbox_1785491685456_262",
            name: "rememberMe",
            type: "boolean",
            label: "Remember Me",
            widget: "checkbox"
          },
          submit: {
            id: "submit_button_initial",
            name: "defaultFormsubmit",
            type: "button",
            label: "Submit",
            buttonType: "submit",
            widget: "button",
            style: "primary",
            disabled: false
          }
        },
        layout: [
          { row: 0, col: 0, field: "emailAddress" },
          { row: 1, col: 0, field: "password" },
          { row: 2, col: 0, field: "rememberMe" },
          { row: 3, col: 0, field: "submit" }
        ],
        settings: {
          name: "Untitled Form"
        }
      }
    };
  },
  methods: {
    onSubmit: function (args) {
      if (args && args.data) {
        // `args.data` holds the form values, `args.isValid` indicates whether
        // every required/validation rule passed.
        console.log(args.data, args.isValid);
      }
    }
  }
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/material3.css";
</style>
<template>
  <ejs-formrenderer :schema="schema" :submit="onSubmit"></ejs-formrenderer>
</template>

<script>
import {
  FormRendererPlugin,
  FormRendererComponent
} from "@syncfusion/ej2-vue-form-renderer";

export default {
  name: "App",
  // Register the Form Renderer plugin so that all form fields are globally registered.
  provide: {
    FormRendererPlugin: [FormRendererPlugin]
  },
  components: {
    "ejs-formrenderer": FormRendererComponent
  },
  // Import the bundled module that wires up every built-in widget (textbox, checkbox, button, etc.).
  data() {
    return {
      schema: {
        version: "0.1.0",
        properties: {
          emailAddress: {
            id: "textbox_1785491685456_167",
            name: "emailAddress",
            type: "string",
            label: "Email Address",
            textboxType: "email",
            required: true,
            widget: "textbox"
          },
          password: {
            id: "textbox_1785491685456_537",
            name: "password",
            type: "string",
            label: "Password",
            textboxType: "password",
            required: true,
            minLength: 6,
            widget: "textbox"
          },
          rememberMe: {
            id: "checkbox_1785491685456_262",
            name: "rememberMe",
            type: "boolean",
            label: "Remember Me",
            widget: "checkbox"
          },
          submit: {
            id: "submit_button_initial",
            name: "defaultFormsubmit",
            type: "button",
            label: "Submit",
            buttonType: "submit",
            widget: "button",
            style: "primary",
            disabled: false
          }
        },
        layout: [
          { type: "field", propertyId: "emailAddress" },
          { type: "field", propertyId: "password" },
          { type: "field", propertyId: "rememberMe" },
          { type: "field", propertyId: "submit" }
        ],
        settings: {
          name: "Untitled Form"
        }
      }
    };
  },
  methods: {
    onSubmit: function (args) {
      if (args.data) {
        // `args.data` holds the form values, `args.isValid` indicates whether
        // every required/validation rule passed.
        console.log(args.data, args.isValid);
      }
    }
  }
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-material3-theme/styles/material3.css";
</style>

Run the project

To run the project, use the following command:

npm run dev
yarn run dev

The output will appear as follows:

Vue Form Renderer

Registering Syncfusion license

The Syncfusion® Vue Form Renderer requires a valid license key to be registered in the application. To prevent license validation warnings, refer to the Syncfusion licensing documentation.

See also

Getting Started with Angular Form Renderer component

06 Aug 20268 minutes to read

The Form Renderer is a powerful, schema-driven component that enables you to build and render complex forms with ease using a structured JSON schema definition. It streamlines form creation, customization, and data capture by letting you declaratively define form layouts, fields, and validation, and then render the form through a simple component property binding.

This guide demonstrates how to set up and configure the Syncfusion® Angular Form Renderer component, from initial installation through setting up the form schema in the component.

Note: This guide supports Angular 21 and other recent Angular versions. For detailed compatibility with other Angular versions, please refer to the Angular version support matrix. Starting from Angular 19, standalone components are the default, and this guide reflects that architecture.

Prerequisites

Setup the Angular application

A straightforward approach to getting started with Angular is to create a new application using the Angular CLI. Install Angular CLI globally with the following command:

npm install -g @angular/cli

To install a particular version of Angular CLI, use:

npm install -g @angular/[email protected]

Angular 21 Standalone Architecture: Standalone components are the default in Angular 21. This guide uses the modern standalone architecture. If you need more information about the standalone architecture, refer to the Standalone Guide.

Create a new application

With Angular CLI installed, use this command to generate a new application:

ng new syncfusion-angular-app
  • This command will prompt you to configure settings like enabling Angular routing and choosing a stylesheet format.
? Which stylesheet format would you like to use? (Use arrow keys)
> CSS             [ https://developer.mozilla.org/docs/Web/CSS                     ]
  Sass (SCSS)     [ https://sass-lang.com/documentation/syntax#scss                ]
  Sass (Indented) [ https://sass-lang.com/documentation/syntax#the-indented-syntax ]
  Less            [ http://lesscss.org                                             ]
  • By default, a CSS-based application is created. Use SCSS if required:
ng new syncfusion-angular-app --style=scss
  • During project setup, when prompted for the Server-side rendering (SSR) option, choose the appropriate configuration.

Initial_setup

  • Select the required AI tool, or choose ‘None’ if you do not need one.

Initial_setup

  • Navigate to your newly created application directory:
cd syncfusion-angular-app

Note: In Angular 19 and earlier, the project uses app.component.ts, app.component.html, and app.component.css, and so on. In Angular 20+, the CLI generates a simpler structure with app.ts, app.html, and app.css (no .component. suffixes).

Adding the Syncfusion® Angular Form Renderer package

To install the Syncfusion® Angular Form Renderer package, use the following command:

ng add @syncfusion/ej2-angular-form-renderer

The ng add command installs the package, registers it in package.json, and configures the required entries in your workspace automatically.

If ng add is unavailable in your setup, install the package manually with:

npm install @syncfusion/ej2-angular-form-renderer

Adding CSS reference

Themes for the Syncfusion® Form Renderer component can be applied using CSS files provided through npm theme packages. For available themes, refer to the Themes documentation.

Install the Material 3 theme package using the following npm command:

npm install @syncfusion/ej2-material3-theme

Then add the following CSS reference to the src/styles.css file. This is the default global stylesheet registered under styles in angular.json:

@import "../node_modules/@syncfusion/ej2-material3-theme/styles/material3.css";

Add Syncfusion® Form Renderer component

After package and theme setup, update the root component. File and class names can vary by Angular CLI version (src/app/app.ts with export class App, or app.component.ts with AppComponent). Replace the root component content with the sample below, or merge the Form Renderer import, schema, and event handler into your generated file.

The Form Renderer is a schema-driven component. Define your form by passing a JSON schema to the schema property of the <ej2-form-renderer> element, and capture the submitted form data through the submit event.

import { Component } from '@angular/core';
import { FormRendererAllModule, Schema } from '@syncfusion/ej2-angular-form-renderer';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [FormRendererAllModule],
  template: `<ejs-form-renderer [schema]="schema" (submit)="onSubmit($event)"></ejs-form-renderer>`
})

export class AppComponent {
  public schema: Schema = {
    "version": "0.1.0",
    "properties": {
      "emailAddress": {
        "id": "textbox_1785491685456_167",
        "name": "emailAddress",
        "type": "string",
        "label": "Email Address",
        "textboxType": "email",
        "required": true,
        "widget": "textbox"
      },
      "password": {
        "id": "textbox_1785491685456_537",
        "name": "password",
        "type": "string",
        "label": "Password",
        "textboxType": "password",
        "required": true,
        "minLength": 6,
        "widget": "textbox"
      },
      "rememberMe": {
        "id": "checkbox_1785491685456_262",
        "name": "rememberMe",
        "type": "boolean",
        "label": "Remember Me",
        "widget": "checkbox"
      },
      "submit": {
        "id": "submit_button_initial",
        "name": "defaultFormsubmit",
        "type": "button",
        "label": "Submit",
        "buttonType": "submit",
        "widget": "button",
        "style": "primary",
        "disabled": false
      }
    },
    "layout": [
      {
        "type": "field",
        "propertyId": "emailAddress"
      },
      {
        "type": "field",
        "propertyId": "password"
      },
      {
        "type": "field",
        "propertyId": "rememberMe"
      },
      {
        "type": "field",
        "propertyId": "submit"
      }
    ],
    "settings": {
      "name": "Untitled Form"
    }
  };
  public onSubmit(args: any) {
    if(args.data){
    console.log(args.data, args.isValid);
    }
  }
}

Running the application

Run the application using the following command:

ng serve

When the build succeeds, the CLI reports a local URL (default: http://localhost:4200). Open that URL in a browser to view the Form Renderer. If the port is already in use, the CLI prompts for another port, or you can run ng serve --port 4201.

The output will appear as follows:

Angular Form Renderer

See Also